#!/usr/bin/ruby
require 'yaml'
require 'colorize'

class Droid

  FILE = 'droid.yml'
  COMMANDS = "commands"
  SYNTAX = "syntax"
  DESC = "desc"
  RUN = "run"

  def load
    YAML.load_file(FILE)
  end

  def save(data)
    File.open(FILE, 'w') { |f| YAML.dump(data, f) }
  end

  def list_commands
    loaded_file = load
    abort("No commands found in droid.yml") unless loaded_file

    commands = loaded_file[COMMANDS]
    puts "Usage: #{"droid".green} #{"<command>".yellow} #{"[args...] [options...]".blue}"
    commands.each do |command|
      puts "\n#{"droid".green} #{command[0].green} #{command[1][SYNTAX] ? command[1][SYNTAX] : ""}"
      puts "  #{command[1][DESC]}"
    end
  end

  def handle_command(command)
    commands = load[COMMANDS]
    command = commands[command]
    if !command
      list_commands
      abort()
    end

    system("#{command[RUN]} #{ARGV[1..ARGV.count].join(' ')}")
  end

  def run
    File.file?('./droid.yml')
    if !File.file?('./droid.yml')
        abort('Could not find droid.yml')
    end
    # Main runner code
    command = ARGV[0]
    if !command
      list_commands
    else
      handle_command(command)
    end
  end

end
